## bigloo-4.6a-1.src.tar.gz

=== Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/Makefile                      */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Jan 14 13:40:15 1998                          */
#*    Last change :  Wed Nov 27 11:39:02 2024 (serrano)                */
#*    Copyright   :  1998-2024 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    This Makefile *requires* GNU-Make.                               */
#*    -------------------------------------------------------------    */
#*    The main Bigloo Makefile. Here is a short description of the     */
#*    makefile entries.                                                */
#*                                                                     */
#*    Public entries:                                                  */
#*      boot........... Compile Bigloo on a bare plateform.            */
#*      boot-api....... Compile Bigloo APIs.                           */
#*      compile-bee0...                                                */
#*      compile-bee.... Compile BEE on a bare plateform.               */
#*                      The entry uses auxiliary public points.        */
#*      install........ Install a compiled Bigloo.                     */
#*      install-bee0...                                                */
#*      install-bee.... Install a compiled Bigloo. This uses           */
#*                      install-xxx entry points).                     */
#*      install-api.... Install Bigloo APIs.                           */
#*      uninstall...... Uninstall the bigloo system and Bee.           */
#*      uninstall-bee0.                                                */
#*      uninstall-bee.. Uninstall Bee. This uses uninstall-xxx points. */
#*      unconfigure.... Unconfigure the bigloo system and Bee.         */
#*      test........... Test a compiled Bigloo.                        */
#*      clean.......... Cleaning.                                      */
#*      distclean...... Cleaning.                                      */
#*                                                                     */
#*    Private entries:                                                 */
#*      fullbootstrap.. Bootstrap a development compiler (private)     */
#*      hostboot....... Compile Bigloo on already provided plateform.  */
#*                      This is not guarantee to work because it       */
#*                      requires a compatible installed Bigloo         */
#*                      compiler (public)                              */
#*      distrib........ Produces an official bigloo tarball file       */
#*                      (private). The tarball file is built from a    */
#*                      bootstrapped compiler that is freshly checked  */
#*                      out from the revision system. Uses (true-      */
#*                      distrib, bigloo.tar.gz, bigloo.tar).           */
#*      distrib-jvm.... Produces an official bigloo zip file with      */
#*                      default back-end set to jvm (for Windows and   */
#*                      MacIntosh boxes).                              */
#*      zip............ aka for distrib-jvm                            */
#*      rpm............ Produces an rpm file for Bigloo.               */   
#*      newrevision.... Changes the development Bigloo revision.       */
#*      pop............ The population that composes Bigloo.           */
#*      popfilelist.... The sort file list of the Bigloo population.   */
#*      revision....... commit a revision (uses prcs-revision and      */
#*                      mercurial-revision).                           */
#*      checkout....... commit a checkout (uses prcs-checkout and      */
#*                      mercurial-checkout).                           */
#*      checkgmake..... Check that make is gmake.                      */
#*=====================================================================*/
 
#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
-include Makefile.buildconfig
-include Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# the shell to be used
SHELL           = /bin/sh
# The directory where to build and install a distribution
DISTRIBTMPDIR	= /tmp
DISTRIBDIR	= $$HOME/prgm/distrib
BUILDDIRNAME 	= bigloo
# The Bigloo html page directory
HTMLPAGEDIR	= $$HOME/public_html/bigloo
# The library to be installed on the ftp server
FTP_LIBRARIES	= contrib/lib-example.tar.gz
# the libc we are testing for version
LIBC		= /usr/lib/libc.so
# the library C version
LIBCVERSION	= 6
# the rpm architecture (for now only i386 is supported)
RPMARCH		= i686
# the root directory where to remove directory after the rpm contruction
RPMBASEDIR	= /usr/src/RPM
RPMSOURCEDIR	= $(RPMBASEDIR)/SOURCES
RPMBUILDDIR	= $(RPMBASEDIR)/BUILD
# The rpm source directory
RPMSOURCESDIR	= $(RPMBASEDIR)/SOURCES
RPMRPMDIR	= $(RPMBASEDIR)/RPMS
# The JVM standard installation directory
JVMBASEDIR	= "C:\\\\\\\\Bgl`echo $(RELEASE) | sed -e 's/[.]//'`"
# gzip
GZIP		= gzip -9
# zip
ZIP		= zip
# The revision system, either prcs, or mercurial
REVISIONSYSTEM	= git
# The message to log the revision
LOGMSG		= ""
# Sudo command
SUDO		= sudo

BOOTCAPI	= no
HOSTBOOTMAKEOPT	= 

#*---------------------------------------------------------------------*/
#*    The directory that compose a version                             */
#*---------------------------------------------------------------------*/
DIRECTORIES	= cigloo \
                  jigloo \
                  bench \
	          autoconf \
                  etc \
                  examples \
                  recette \
                  tools \
                  xlib \
                  runtime \
	          comptime \
		  bdb \
                  bde \
                  bmacs \
                  manuals \
                  doc \
                  win32 \
                  arch \
                  www \
                  api \
                  srfi \
                  bdl \
                  bglpkg \
                  gc \
                  gmp \
                  pcre \
                  pcre2 \
                  libunistring \
                  libbacktrace \
                  libuv

#*---------------------------------------------------------------------*/
#*    The file that have to be removed when building a distrib.        */
#*---------------------------------------------------------------------*/
NO_DIST_FILES	= .bigloo.prcs_aux \
		  bigloo.lsm \
		  www

#*---------------------------------------------------------------------*/
#*    boot ...                                                         */
#*    -------------------------------------------------------------    */
#*    Boot a new Bigloo system on a new host. This boot makes use      */
#*    of the pre-compiled C files.                                     */
#*---------------------------------------------------------------------*/
.PHONY: checkconf boot boot-jvm boot-bde boot-api boot-bglpkg

build: checkconf $(BOOTMETHOD)

# boot from pre-bootstrapped version
bootstrap: boot

# boot from a pre-compiled version
c: boot

# boot from the source using a pre-install bigloo version
cross:
	$(MAKE) hostboot BGLBUILDBINDIR=$(BOOTBIGLOOBINDIR)

# boot from a bare platform
source:
	if [ ! -x download/bin/bigloo ]; then \
	  (cd download; tar xvfz bigloo-$(BOOTBUILDRELEASE).tar.gz); \
	  (pwd=`pwd`; cd download/bigloo-$(BOOTBUILDRELEASE); ./configure --prefix=$$pwd/download && make && make install); \
        fi
	$(MAKE) cross BOOTBIGLOOBINDIR=$$PWD/download/bin

checkconf:
	@ if ! [ -f "lib/bigloo/$(RELEASE)/bigloo.h" ]; then \
	  echo "you must configure before building!"; \
	  exit 1; \
	fi

boot: boot-c
	if [ "$(JVMBACKEND)" = "yes" ]; then \
	  $(MAKE) boot-jvm; \
        fi
	$(MAKE) boot-bde
	$(MAKE) boot-api
	if [ "$(ENABLE_BGLPKG)" = "yes" ]; then \
	  $(MAKE) boot-bglpkg; \
        fi
	@ echo "\e[1;34mboot\e[0m done..."

boot-c: checkgmake
	if [ "$(GMPCUSTOM)" = "yes" ]; then \
	  $(MAKE) -C gmp boot; \
        fi
	if [ "$(LIBUVCUSTOM)" = "yes" ]; then \
	  $(MAKE) -C libuv boot; \
        fi
	if [ "$(GCCUSTOM)" = "yes" ]; then \
	  $(MAKE) -C gc boot; \
        fi
	if [ "$(PCRE2CUSTOM)" = "yes" ]; then \
	  $(MAKE) -C pcre2 boot; \
        fi
	if [ "$(PCRECUSTOM)" = "yes" ]; then \
	  $(MAKE) -C pcre boot; \
        fi
	if [ "$(UNISTRINGCUSTOM)" = "yes" ]; then \
	  $(MAKE) -C libunistring boot; \
        fi
	if [ "$(LIBBACKTRACECUSTOM)" = "yes" ]; then \
	  $(MAKE) -C libbacktrace boot; \
        fi
	if [ -x $(BGLBUILDBINDIR)/bigloo ]; then \
	  $(MAKE) -C runtime .afile && \
	  $(MAKE) -C runtime heap && \
          $(MAKE) boot-touch-specific && \
	  $(MAKE) -C runtime boot && \
          $(MAKE) boot-touch-specific && \
	  $(MAKE) -C runtime lib && $(MAKE) -C runtime lib_u && \
	  $(MAKE) -C comptime bigloo && $(MAKE) -C comptime boot; \
	else \
	  $(MAKE) -C runtime boot && \
	  $(MAKE) -C comptime boot && \
	  $(MAKE) -C runtime heap; \
	fi
	# touch the generic Scheme source files that must be
	# recompiled with the configured options (e.g., gmp or pcre2)
	$(MAKE) boot-touch-specific
	$(MAKE) -C runtime lib && $(MAKE) -C runtime lib_u

# This touches the runtime file that depends on some platform
# configurations and that needs to be re-compiled because
# the shipped intermediate C file use a generic implementation
# that is not compatible with the specific autoconfiguration versions
.PHONY: boot-touch-specific
boot-touch-specific:
	touch runtime/Eval/evprimop.scm
	touch runtime/Unsafe/regexp.scm
	touch runtime/Ieee/fixnum.scm runtime/Ieee/number.scm runtime/Unsafe/bignumber.scm runtime/Llib/os.scm runtime/Unsafe/rsa.scm runtime/Clib/cbignum.c runtime/Clib/cmain.c

boot-jvm: checkgmake
	$(MAKE) -C runtime boot-jvm

boot-bde:
	$(MAKE) -C bde boot BFLAGS="$(BFLAGS) $(SHRD_BDE_OPT)"

boot-api:
	$(MAKE) -C api boot BFLAGS="$(BFLAGS)"

boot-bglpkg:
	$(MAKE) -C bglpkg BFLAGS="$(BFLAGS)"

#*---------------------------------------------------------------------*/
#*    cross-rts ...                                                    */
#*    -------------------------------------------------------------    */
#*    This entry builds the Bigloo runtime system using a cross        */
#*    C compiler. It needs an operational pre-install native Bigloo    */
#*    compiler and a cross C compiler on the current host.             */
#*---------------------------------------------------------------------*/
cross-rts: checkgmake
	$(MAKE) -C runtime boot
	$(MAKE) -C runtime heap
	if [ "$(JVMBACKEND)" = "yes" ]; then \
           (PATH=$(BOOTBINDIR):$$PATH; export PATH; \
            $(MAKE) -C runtime boot-jvm); \
        fi
	$(MAKE) -C api boot)
	@ echo "\e[1;34mcross-rts\e[0m done..."

#*---------------------------------------------------------------------*/
#*    manuals                                                          */
#*---------------------------------------------------------------------*/
manuals:
	@ (cd manuals && $(MAKE) html ps)
	@ (cd manuals && $(MAKE) compile-bee)

#*---------------------------------------------------------------------*/
#*    manual-pdf                                                       */
#*---------------------------------------------------------------------*/
manual-pdf:
	@ (cd manuals && $(MAKE) bigloo.pdf)

=== api/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/api/Makefile                  */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Thu Mar 24 05:30:44 2005                          */
#*    Last change :  Fri Mar 11 19:13:33 2022 (serrano)                */
#*    Copyright   :  2005-22 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    The API Makefile                                                 */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    DIRECTORIES                                                      */
#*---------------------------------------------------------------------*/
DIRECTORIES= pthread srfi18 fthread mail ssl web multimedia sqlite calendar \
             srfi1 pkgcomp pkglib gstreamer text packrat srfi27 crypto \
             openpgp phone alsa mpg123 flac wav avahi csv phidget upnp libuv \
             pulseaudio libbacktrace mqtt

#*---------------------------------------------------------------------*/
#*    Booting on a bare system                                         */
#*---------------------------------------------------------------------*/
boot: bootall

fullbootstrap:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
	    echo "[0m[1;35m$$d:[0m"; \
            $(MAKE) -C $$d clean && $(MAKE) -C $$d boot || exit 1; \
	  done

bootall:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
	    echo "[0m[1;35m$$d:[0m"; \
            $(MAKE) -C $$d boot || exit 1; \
	  done

boot-c:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
	    echo "[0m[1;33m$$d:[0m"; \
            $(MAKE) -C $$d boot-c || exit 1; \
          done

boot-jvm:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
            if [ "$(JVMBACKEND)" = "yes" ]; then \
	      echo "[0m[1;33m$$d:[0m"; \
              $(MAKE) -C $$d boot-jvm || exit 1; \
            fi; \
          done

boot-dotnet:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
            if [ "$(DOTNETBACKEND)" = "yes" ]; then \
	      echo "[0m[1;33m$$d:[0m"; \
              $(MAKE) -C $$d boot-dotnet || exit 1; \
            fi \
          done

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
.PHONY: clean-quick clean cleanall distclean

clean-quick:
	@ for d in $(DIRECTORIES) ; do \
             if [ -d $$d ]; then \
               (cd $$d/src; rm -f .afile); \
             fi \
          done;

clean:
	@ for d in $(DIRECTORIES) ; do \
             if [ -d $$d ]; then \
               $(MAKE) -C $$d clean; \
             fi \
          done;

cleanall: 
	@ for d in $(DIRECTORIES) ; do \
             if [ -d $$d ]; then \
               $(MAKE) -C $$d cleanall; \
             fi \
          done;

distclean: 
	@ for d in $(DIRECTORIES) ; do \
             if [ -d $$d ]; then \
               $(MAKE) -C $$d distclean; \
             fi \
          done;

#*---------------------------------------------------------------------*/
#*    install & uninstall                                              */
#*---------------------------------------------------------------------*/
.PHONY: install install-devel uninstall uninstall-devel

install:
	if [ "$(APIS) " != " " ]; then \
          for d in $(APIS) ; do \
            install=true; \
	    if [ "$(NOAPIS) " != " " ]; then \
              for n in $(NOAPIS) ; do \
                if [ "$$n " = "$$d " ]; then \
                  install=false; \
                  break; \
                fi; \
              done; \
            fi; \
            if [ "$$install " = "true " ]; then \
              $(MAKE) -C $$d install || exit 1; \
            fi; \
          done \
        fi

install-devel:
	(cp Makefile.api $(DESTDIR)$(LIBDIR)/$(FILDIR)/Makefile.api && \
         chmod $(MODFILE) $(DESTDIR)$(LIBDIR)/$(FILDIR)/Makefile.api)
	(cp Makefile.api-safe $(DESTDIR)$(LIBDIR)/$(FILDIR)/Makefile.api-safe && \
         chmod $(MODFILE) $(DESTDIR)$(LIBDIR)/$(FILDIR)/Makefile.api-safe)

uninstall:
	if [ "$(APIS) " != " " ]; then \
          for d in $(APIS) ; do \
            $(MAKE) -C $$d uninstall; \
          done \
        fi

uninstall-devel:
	$(RM) -f $(DESTDIR)$(LIBDIR)/$(FILDIR)/Makefile.api
	$(RM) -f $(DESTDIR)$(LIBDIR)/$(FILDIR)/Makefile.api-safe

#*---------------------------------------------------------------------*/
#*    Populating the APIs                                              */
#*---------------------------------------------------------------------*/
pop: 
	@ for d in $(DIRECTORIES) ; do \
             for f in `cd $$d && $(MAKE) -s pop;`; do \
                echo api/$$f; \
             done; \
          done;
	@ echo api/Makefile api/Makefile.api api/Makefile.api-safe api/README

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    Prepare for a distribution                                       */
#*---------------------------------------------------------------------*/
distrib: 
	@ if [ `pwd` = $(BOOTDIR)/api ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi
	@ for d in $(DIRECTORIES); do \
             if [ -d $$d ]; then \
               $(MAKE) -C $$d distrib; \
             fi; \
          done;
	@ $(RM) -f api/Makefile~

=== arch/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/arch/Makefile                 */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Sun Feb  7 07:40:11 2010                          */
#*    Last change :  Tue Apr 21 16:47:53 2020 (serrano)                */
#*    Copyright   :  2010-20 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    The Makefile that handles arch specific parts.                   */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    DIRECTORIES                                                      */
#*---------------------------------------------------------------------*/
DIRECTORIES= macosx debian archlinux android raspberry homebrew

#*---------------------------------------------------------------------*/
#*    Populating the ARCHs                                             */
#*---------------------------------------------------------------------*/
pop: 
	@ for d in $(DIRECTORIES) ; do \
             for f in `cd $$d && $(MAKE) -s pop;`; do \
                echo arch/$$f; \
             done; \
          done;
	@ echo arch/Makefile


#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:

=== autoconf/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/autoconf/Makefile             */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Thu Jun 19 20:48:50 1997                          */
#*    Last change :  Fri Dec  8 08:15:24 2023 (serrano)                */
#*    Copyright   :  1997-2023 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The global autoconf Makefile.                                    */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Default configuration                                            */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config
include ../Makefile.misc

#*---------------------------------------------------------------------*/
#*    Flags                                                            */
#*---------------------------------------------------------------------*/
POPULATION	= Makefile bigloo.sh.in bglafile.sh.in bglmco.sh.in \
		  bgljfile.sh.in bgltags.sh.in bgldepend.sh.in \
                  bglrun.sh.in bglld.sh.in bglmake.sh.in bglprof.sh.in \
                  bglpp.sh.in bgljas.sh.in \
                  bigloo_config.h.in bigloo_gc.h.in \
                  configure.java.in \
                  bigloo_config.sch.in \
                  mkruntest runtest.in \
                  os osversion cpu \
                  checkmember checkinclude \
                  cnstalign longlong labs llabs strtoll strtoull \
                  sigpipe sigsetmask \
                  alignment enforcedcnstalign pipe sigsetmask.ucb \
                  alloca allocah getcwd ptrsize stackdown \
                  ascpp getwd ranlib unix dirname \
                  bcopy indent setjmp setjmp.sparc winreg \
                  bigendian ldshare ldpreload ldsoname sigprocmask \
                  sigchld sigaction siginfo \
                  doubleprec xemacspath ldstaticopt ldsharedopt \
                  readline ldextraopt \
                  socket getaddrinfo getifaddrs gethwaddrs socklen setsockopt \
                  inet_aton inet_pton \
                  unixsocket info cctest ccoptim ccbracket ccdiv0 ccwarning \
                  ccprof ccfp termio termios installinfo installinfodir \
                  dlopen user xemacsbin gmaketest ccpic ccpic2 ccssex86 \
                  ziptest javatest jartest \
                  oscharset strip cygwindospath select fcntl ccstrip \
                  emacsbrand emacslisppath stacksize gcstd \
                  thread pthread pthreadlock pthreadspinlock pthreadcancel \
                  pthreadmutexrec pthreadtimedjoin pthreadlocalstorage \
                  pthreadcondvtimedwait processor sendfile sleep posixfileops \
                  timezone timeval gcflags mmap macosx sqlite \
                  openssl openssl-dtls openssl-tls11 openssl-tls1 \
                  openssl-tls12 openssl-tls13 openssl-rand \
                  openssl-v2 openssl-v3 \
                  openssl-v23 openssl-getter \
                  stdint stdlibint unistdint stdc stdcwarning \
                  maemo.arm android \
                  gcversion gchavedoblocking gchavestartblocking nbprocs \
                  gstreamer gstreameraudio \
                  alsa pulseaudio mpg123 flac pcre pcrefreestudy pcre2 avahi \
                  dbus gmp resolv resolvsym unistring limbs signbit rdynamic \
                  getuid getgid gecos getprotoent machdep arflags mixer \
                  config.guess ccfortify environ setenv symlink \
                  androidmkdir bgl-pkg-config phidget phidgetlibdir \
                  gmtoff localtime_r gmtime_r timegm libuv getgroups ioctl \
                  pthreadkill syslog overflow semaphore lockf likely \
                  gccattrs getrlimit c99stackalloc tools bootmethod musttail \
                  clocklib

#*---------------------------------------------------------------------*/
#*    pop ...                                                          */
#*---------------------------------------------------------------------*/
pop:
	@ echo $(POPULATION:%=autoconf/%)

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean
clean:
	@ find . \( -name '*[~%]'                   \
                       -o -name '.??*[~%]'          \
                       -o -name '#*#'               \
                       -o -name '?*#'               \
                       -o -name \*core \)           \
                     -type f -exec rm {} \;   
	@ echo "cleanup done..."
	@ echo "-------------------------------"

cleanall: clean
distclean: clean

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
	@ if [ `pwd` = $(BOOTDIR)autoconf ]; then     \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`";   \
             exit 1;                                                 \
          fi
	@ $(MAKE) clean
	@ chmod a+rx $(POPULATION)

#*---------------------------------------------------------------------*/
#*    install                                                          */
#*---------------------------------------------------------------------*/
.PHONY: install uninstall

install:
	cp runtest $(DESTDIR)$(LIBDIR)/$(FILDIR)/runtest && \
          chmod $(MODEXE) $(DESTDIR)$(LIBDIR)/$(FILDIR)/runtest; \

uninstall:
	$(RM) -f $(DESTDIR)$(LIBDIR)/$(FILDIR)/runtest

=== bdb/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/bdb/Makefile                  */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Aug  4 20:11:07 1999                          */
#*    Last change :  Wed Jun 26 15:01:47 2024 (serrano)                */
#*    Copyright   :  1999-2024 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The bdb Makefile                                                 */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    The directory that compose a version                             */
#*---------------------------------------------------------------------*/
DIRECTORIES	= bdb blib

#*---------------------------------------------------------------------*/
#*    Booting bdb on a bare system                                     */
#*---------------------------------------------------------------------*/
boot: boot-blib boot-bdb

boot-blib:
	@ $(MAKE) -C blib all

boot-bdb:
	@ $(MAKE) -C bdb MODE=final mode

#*---------------------------------------------------------------------*/
#*    Populating bdb                                                   */
#*---------------------------------------------------------------------*/
pop: 
	@ for d in $(DIRECTORIES) ; do \
             for f in `cd $$d; $(MAKE) -s pop;`; do \
                echo bdb/$$d/$$f; \
             done; \
          done;
	@ echo bdb/Makefile

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean

clean:
	@ for d in $(DIRECTORIES) ; do \
             ($(MAKE) -C $$d ROOT="$(ROOT)" clean); \
          done;

cleanall: 
	@ for d in $(DIRECTORIES) ; do \
             ($(MAKE) -C $$d ROOT="$(ROOT)" cleanall); \
          done;

distclean: 
	@ for d in $(DIRECTORIES) ; do \
             ($(MAKE) -C $dd ROOT="$(ROOT)" cleanall); \
          done;


#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    Prepare bdb for a distribution                                   */
#*---------------------------------------------------------------------*/
distrib: 
	@ if [ `pwd` = $(BOOTDIR)/bdb ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi
	@ for d in $(DIRECTORIES) ; do \
             $(MAKE) -C $$d ude; \
          done;
	@ $(RM) -f bdb/Makefile~

#*---------------------------------------------------------------------*/
#*    install & uninstall                                              */
#*---------------------------------------------------------------------*/
.PHONY: install uninstall

include ../Makefile.misc

install:
	if [ $(DESTDIR)$(BINDIR) != $(BOOTBINDIR) ]; then \
	   cp $(BOOTBINDIR)/bdb $(DESTDIR)$(BINDIR) && \
	   chmod $(MODEXE) $(DESTDIR)$(BINDIR)/bdb; \
        fi
	if [ $(DESTDIR)$(LIBDIR)/$(FILDIR) != $(BOOTLIBDIR) ]; then \
	   cp $(BOOTLIBDIR)/bdb.heap $(DESTDIR)$(LIBDIR)/$(FILDIR)/bdb.heap && \
           chmod $(MODFILE) $(DESTDIR)$(LIBDIR)/$(FILDIR)/bdb.heap || exit 1; \
        fi
	$(MAKE) install-lib LIB=libbigloobdb_s-$(RELEASE)


uninstall:
	-$(RM) -f $(DESTDIR)$(BINDIR)/bdb
	-$(RM) -f $(DESTDIR)$(LIBDIR)/bdb.heap
	-$(MAKE) uninstall-lib LIB=libbigloobdb_s-$(RELEASE)

=== bde/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/bde/Makefile                  */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Mon Jun  8 08:36:43 1998                          */
#*    Last change :  Tue Mar 24 15:47:47 2020 (serrano)                */
#*    Copyright   :  1998-2020 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The Makefile for the Bigloo development environment.             */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# etags for info
ETAGS		= etags
# etags flags for info scanning
ETFLAGS		= --language=none \
                  --r '/^ - \(essential \|library \|bigloo \)?\(procedure\|syntax\): [^ ]+/' \
                  --r '/^ - bigloo module clause: [^ ]+/' \
                  --r '/^ - bigloo rgc procedure: [^ ]+/' \
                  --r '/^ - bigloo generic: [^ ]+/'
# the shell to be used
SHELL           = /bin/sh

#*---------------------------------------------------------------------*/
#*    Compilation flags                                                */
#*---------------------------------------------------------------------*/
#BFLAGS		= -jvm -jvm-jar -O2 -fsharing -unsafe
BFLAGS		= -O2 -fsharing -unsafe $(SHRD_BDE_OPT) -lib-dir $(BOOTLIBDIR)
EFLAGS		=

#*---------------------------------------------------------------------*/
#*    Sources and Objects                                              */
#*---------------------------------------------------------------------*/
#*--- afile -----------------------------------------------------------*/
AFILE_FILE	= afile
AFILE_OBJ	= $(AFILE_FILE:%=afile/%.o)

#*--- jfile -----------------------------------------------------------*/
JFILE_FILE	= jfile
JFILE_OBJ	= $(JFILE_FILE:%=jfile/%.o)

#*--- bpp -------------------------------------------------------------*/
BPP_FILE	= bpp reader
BPP_OBJ		= $(BPP_FILE:%=bpp/%.o)

#*--- btags -----------------------------------------------------------*/
BTAGS_FILE	= btags
BTAGS_OBJ	= $(BTAGS_FILE:%=btags/%.o)

#*--- bdepend ---------------------------------------------------------*/
BDEPEND_FILE	= bdepend
BDEPEND_OBJ	= $(BDEPEND_FILE:%=bdepend/%.o)

#*--- bmake -----------------------------------------------------------*/
BMAKE_FILE	= bmake template
BMAKE_OBJ	= $(BMAKE_FILE:%=bmake/%.o)

#*--- bprof -----------------------------------------------------------*/
BPROF_FILE	= bprof
BPROF_OBJ	= $(BPROF_FILE:%=bprof/%.o)

#*--- mco -------------------------------------------------------------*/
MCO_FILE	= mco
MCO_OBJ		= $(MCO_FILE:%=mco/%.o)

#*--- jas -------------------------------------------------------------*/
JAS_LINKFILE	= lib classfile peep opcode wide labels stack produce as \
                  profile
JAS_FILE	= jas 
JAS_AFILE	= jas/.afile
JAS_LINKSRC	= $(JAS_LINKFILE:%=jas/%.scm)
JAS_LINKOBJ	= $(JAS_LINKFILE:%=jas/%.o)
JAS_OBJ		= $(JAS_FILE:%=jas/%.o)

#*---------------------------------------------------------------------*/
#*    Population                                                       */
#*---------------------------------------------------------------------*/
OBJECTS		= $(AFILE_OBJ) $(BPP_OBJ) $(BTAGS_OBJ) $(BDEPEND_OBJ) \
                  $(BMAKE_OBJ) $(BPROF_OBJ) $(MCO_OBJ) $(JFILE_OBJ) \
                  $(JAS_OBJ)
SOURCES_FILES	= $(OBJECTS:%.o=%.scm)

POPULATION	= $(SOURCES_FILES) \
                  bpp/README \
	          bmake/makefile.appli \
	          bmake/makefile.library \
                  jas/jas.tex \
                  Makefile

#*---------------------------------------------------------------------*/
#*     Suffixes ...                                                    */
#*---------------------------------------------------------------------*/
.SUFFIXES:
.SUFFIXES: .scm .sch .o .el .elc

#*---------------------------------------------------------------------*/
#*    all                                                              */
#*---------------------------------------------------------------------*/
all: all-common dobmem 
	if [ "$(JVMBACKEND) " != "no " ]; then \
	  $(MAKE) all-jvm; \
	fi

all-common: $(BOOTBINDIR)/bglafile \
     $(BOOTBINDIR)/bgldepend \
     $(BOOTBINDIR)/bglmco \
     $(BOOTBINDIR)/bglmake \
     $(BOOTBINDIR)/bglpp \
     $(BOOTBINDIR)/bgltags \
     $(BOOTBINDIR)/bglprof \
     $(BOOTBINDIR)/bgljfile

all-jvm: $(BOOTBINDIR)/bgljas

boot:
	$(MAKE) all BFLAGS="$(BFLAGS) -ld-relative"

dobmem: $(BOOTBINDIR)/bglafile
	@ if [ "$(LDPRELOADSUPPORT)" = "yes" \
                -a "$(PTHREADLIBS)" != "no" ]; then \
	    (cd bmem && $(MAKE)) || exit 1; \
	  fi

$(BOOTBINDIR)/bglafile: $(AFILE_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $^

afile.class: afile/afile.scm
	(cd afile; \
         $(BIGLOO) -c -jvm $(BFLAGS) $(EFLAGS) afile.scm -o afile.class; \
         mv afile.class ..)

$(BOOTBINDIR)/bgljfile: $(JFILE_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $^

jfile.class: jfile/jfile.scm
	(cd jfile; $(BIGLOO) -c -jvm $(BFLAGS) $(EFLAGS) jfile.scm -o jfile.class; \
         mv jfile.class ..)

$(BOOTBINDIR)/bgldepend: $(BDEPEND_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $^

$(BOOTBINDIR)/bglmake: $(BMAKE_OBJ)
	$(BIGLOO) -no-hello $(BFLAGS) $(EFLAGS) -o $@ $^

$(BOOTBINDIR)/bglprof: $(BPROF_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $^

$(BOOTBINDIR)/bglmco: $(MCO_OBJ) ../comptime/Module/checksum.o
	$(BIGLOO) -no-hello $(BFLAGS) $(EFLAGS) -o $@ $^

$(BOOTBINDIR)/bglpp: $(BPP_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $^

$(BOOTBINDIR)/bgltags: $(BTAGS_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $^

jas: $(BOOTBINDIR)/bgljas
$(BOOTBINDIR)/bgljas: $(JAS_LINKSRC) $(JAS_AFILE) $(JAS_OBJ) $(JAS_LINKOBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $(JAS_OBJ) $(JAS_LINKOBJ)

#*---------------------------------------------------------------------*/
#*    install                                                          */
#*---------------------------------------------------------------------*/
install: all
	if [ $(BINDIR) != $(BOOTBINDIR) ]; then \
	  targets="bglafile bgldepend bglmake bglprof bglmco bglpp bgltags"; \
	  if [ "$(JVMBACKEND) " != "no " ]; then \
	     targets="$$targets bgljfile bgljas"; \
          fi; \
	  for p in $$targets; do \
	    cp $(BOOTBINDIR)/$$p$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/$$p$(EXE_SUFFIX); \
            chmod $(MODEXE) $(DESTDIR)$(BINDIR)/$$p$(EXE_SUFFIX); \
            cat $(BOOTBINDIR)/$$p.sh | \
              sed -e "s|$(BOOTBINDIR)|$(BINDIR)|g" \
                  -e "s|$(BOOTLIBDIR)|$(LIBDIR)/$(FILDIR)|g" \
                  -e "s|(BGLBUILDBINDIR)|$(BINDIR)|g" \
              > $(DESTDIR)$(BINDIR)/$$p.sh && \
            chmod $(MODEXE) $(DESTDIR)$(BINDIR)/$$p.sh; \
          done; \
        fi
	if [ "$(LDPRELOADSUPPORT)" = "yes" -a "$(PTHREADLIBS)" != "no" ]; then \
	  (cd bmem; $(MAKE) install) || exit 1; \
        fi

#*---------------------------------------------------------------------*/
#*    uninstall                                                        */
#*---------------------------------------------------------------------*/
uninstall:
	- $(RM) -f $(DESTDIR)$(BINDIR)/bglafile$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bgljfile$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bgldepend$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bglmake$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bglprof$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bglmco$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bglpp$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bgltags$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bgljas$(EXE_SUFFIX)
	- (cd bmem; $(MAKE) uninstall)

#*---------------------------------------------------------------------*/
#*    touchall                                                         */
#*---------------------------------------------------------------------*/
touchall:
	touch $(SOURCE_FILES)

#*---------------------------------------------------------------------*/
#*     clean ...                                                       */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean

clean:
	@- $(RM) -f $(OBJECTS)
	@- $(RM) -f $(JAS_LINKOBJ)
	@- $(RM) -f $(JAS_LINKFILE:%=jas/%.c)
	@- $(RM) -f $(OBJECTS:%.o=%.c)
	@- $(RM) -f .afile
	@- $(RM) -f jas/.afile
	@- $(RM) -f *.class
	@ find . \( -name '*[~%]' \
                       -o -name '.??*[~%]' \
                       -o -name '#*#' \
                       -o -name '?*#' \
                       -o -name \*core \) \
                     -type f -exec rm {} \;   
	@ (cd bmem; $(MAKE) clean)
	@ $(BEEP)
	@ echo "cleanup done..."
	@ echo "-------------------------------"

cleanall: clean
	@- $(RM) -f $(BOOTBINDIR)/bglafile 
	@- $(RM) -f $(BOOTBINDIR)/bgljfile 
	@- $(RM) -f $(BOOTBINDIR)/bgldepend 
	@- $(RM) -f $(BOOTBINDIR)/bglmake 
	@- $(RM) -f $(BOOTBINDIR)/bglprof
	@- $(RM) -f $(BOOTBINDIR)/bglmco
	@- $(RM) -f $(BOOTBINDIR)/bglpp 
	@- $(RM) -f $(BOOTBINDIR)/bgltags
	@- $(RM) -f $(BOOTBINDIR)/bgljas
	@- $(RM) -f $(JAS_LINKSRC)

distclean: cleanall

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    Prepare Bde for a distribution                                   */
#*---------------------------------------------------------------------*/
distrib:
	@ if [ `pwd` = $(BOOTDIR)/bde ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi
	$(MAKE) -C bmem .afile
	$(MAKE) $(JAS_AFILE)

#*---------------------------------------------------------------------*/
#*    jvm                                                              */
#*---------------------------------------------------------------------*/
jvm: afile.class jfile.class

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*    -------------------------------------------------------------    */
#*    This entry is used by the bigloo/Makefile (the main Bigloo       */
#*    makefile) to get the list of file that populate a revision.      */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=bde/%)
	@ (cd bmem; $(MAKE) pop)

#*---------------------------------------------------------------------*/
#*     .scm --> .o                                                     */
#*---------------------------------------------------------------------*/
jas/%.o: jas/%.scm $(JAS_AFILE)
	$(BIGLOO) $(BFLAGS) -g $(EFLAGS) -c jas/$*.scm -o jas/$*.o -afile jas/.afile

%.o: %.scm
	$(BIGLOO) $(BFLAGS) -g $(EFLAGS) -c $*.scm -o $*.o

#*---------------------------------------------------------------------*/
#*     .scm --> .class                                                 */
#*---------------------------------------------------------------------*/
jas/%.class: jas/%.scm $(JAS_AFILE)
	$(BIGLOO) -jvm $(BFLAGS) $(EFLAGS) -c jas/$*.scm -o jas/$*.class -afile jas/.afile

%.class: %.scm
	$(BIGLOO) -jvm $(BFLAGS) $(EFLAGS) -c $*.scm -o $*.class

#*---------------------------------------------------------------------*/

=== bdl/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bdl/Makefile                         */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Oct  3 05:37:54 2001                          */
#*    Last change :  Sun Jul  9 10:20:21 2017 (serrano)                */
#*    Copyright   :  2001-17 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    This Makefile *requires* GNU-Make.                               */
#*    -------------------------------------------------------------    */
#*    The Makefile for bdl                                             */
#*=====================================================================*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Directories where to find the files composing a revision         */
#*---------------------------------------------------------------------*/
POPDIR = src example

POPULATION = Makefile README

#*---------------------------------------------------------------------*/
#*    all                                                              */
#*---------------------------------------------------------------------*/
.PHONY: build build build-c build-jvm build-dotnet

all: build
boot: build

build:
	@ $(MAKE) build-c && $(MAKE) build-jvm

c: build-c
jvm: build-jvm
dotnet: build-dotnet

build-c:
	@ if [ "$(NATIVEBACKEND)" = "yes" ]; then \
	    echo "[0m[1;32m>>> C[0m"; \
	    $(MAKE) -C src build-c; \
          fi

build-jvm:
	@ if [ "$(JVMBACKEND)" = "yes" ]; then \
	    echo "[0m[1;31m>>> JVM[0m"; \
	    $(MAKE) -C src build-jvm; \
          fi

build-dotnet:
	@ if [ "$(DOTNETBACKEND)" = "yes" ]; then \
	    echo "[0m[1;31m>>> .NET[0m"; \
	    $(MAKE) -C src build-dotnet; \
          fi

#*---------------------------------------------------------------------*/
#*    ude                                                              */
#*---------------------------------------------------------------------*/
ude:
	(cd src && $(MAKE) ude)

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*    -------------------------------------------------------------    */
#*    This entry is used by the bigloo/Makefile (the main Bigloo       */
#*    makefile) to get the list of file that populate a revision.      */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=bdl/%)
	@ for d in $(POPDIR); do \
            $(MAKE) -C $$d -s pop; \
          done;

#*---------------------------------------------------------------------*/
#*    Clean                                                            */
#*---------------------------------------------------------------------*/
clean:
	$(MAKE) -C src clean
	$(MAKE) -C example clean

distclean: clean
cleanall: distclean
	(cd src && $(MAKE) cleanall)
	$(RM) -f lib/*bdl* >/dev/null 2>&1
	$(RM) -f *~ >/dev/null 2>&1

#*---------------------------------------------------------------------*/
#*    Installation                                                     */
#*---------------------------------------------------------------------*/
.PHONY: install uninstall

install:
	$(MAKE) -C src install

uninstall:
	$(MAKE) -C src uninstall

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
	$(MAKE) -C src ude

=== bglpkg/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bglpkg/Makefile                      */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Dec 13 10:04:17 2006                          */
#*    Last change :  Sun Jul  9 10:21:32 2017 (serrano)                */
#*    Copyright   :  2006-17 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    The makefile to build the Bigloo bglpkg command.                 */
#*=====================================================================*/
do: build

#*---------------------------------------------------------------------*/
#*    Default configuration                                            */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
BGLPKG		= bglpkg
BACKEND		= auto

# the executable used to compile
EFLAGS		= 

AFILE_BIN	= $(BGLBUILDBINDIR)/bglafile.sh
JFILE_BIN	= $(BGLBUILDBINDIR)/bgljfile.sh
BTAGS_BIN	= $(BGLBUILDBINDIR)/bgltags.sh
DEPEND_BIN	= $(BGLBUILDBINDIR)/bgldepend.sh

UNZIP		= unzip
JAR		= jar cfm

# standard Jvm library
JVMZIPLIBS	= $(BOOTLIBDIR)/bigloo_s.zip \
                  $(BOOTLIBDIR)/bigloosqlite_s-$(RELEASE).zip \
                  $(BOOTLIBDIR)/bigloopkglib_s-$(RELEASE).zip

#*---------------------------------------------------------------------*/
#*    Sources    					               */
#*---------------------------------------------------------------------*/
SOURCES		= parseargs param utils package action extract tuning \
                  install testing chicken mzscheme snow man main
FILES		= $(SOURCES:%=%.scm)

MODULES		= $(SOURCES) configure

INCLUDES	= param.sch makefile.sch

#*---------------------------------------------------------------------*/
#*    Population                                                       */
#*---------------------------------------------------------------------*/
POPULATION 	= $(INCLUDES) $(FILES) configure.scm.in Makefile \
	          README etc/Makefile etc/make_lib.scm etc/init

#*---------------------------------------------------------------------*/
#*    The bglpkg executable                                            */
#*---------------------------------------------------------------------*/
.PHONY: build auto build.auto native build.native jvm build.jvm build.dotnet

build: build.$(BACKEND)

auto: build.auto
build.auto:
	if [ "$(NATIVEBACKEND)" = "yes" ]; then \
	  $(MAKE) build.native; \
        else \
	  if [ "$(JVMBACKEND)" = "yes" ]; then \
	    $(MAKE) build.jvm; \
          else \
            $(MAKE) build.dotnet; \
          fi \
        fi

#*---------------------------------------------------------------------*/
#*    native version                                                   */
#*---------------------------------------------------------------------*/
native: build.native
build.native: o .afile .etags
	@ $(MAKE) $(BOOTBINDIR)/$(BGLPKG)

$(BOOTBINDIR)/$(BGLPKG): $(MODULES:%=o/%.o)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $@ $+

#*---------------------------------------------------------------------*/
#*    jvm version                                                      */
#*---------------------------------------------------------------------*/
jvm: build.jvm
build.jvm: o/class_s/bigloo/bglpkg .afile .etags .jfile jvm-stdlibs
	@ $(MAKE) $(BOOTBINDIR)/$(BGLPKG).jar

$(BOOTBINDIR)/$(BGLPKG).jar: $(MODULES:%=o/class_s/bigloo/bglpkg/%.class) \
     META-INF/MANIFEST.MF
	$(JAR) $@ META-INF/MANIFEST.MF -C o/class_s .

META-INF/MANIFEST.MF: META-INF
	echo "Manifest-Version: 1.0" > $@
	echo "Main-Class: bigloo/bglpkg/main" >> $@
	echo "Created-By: Bigloo $(RELEASE)" >> $@

META-INF:
	mkdir -p $@

jvm-stdlibs: o/class_s
	for p in $(JVMZIPLIBS); do \
          if [ -f $$p ]; then \
             $(UNZIP) -d o/class_s -o -u $$p; \
          else \
             echo "*** ERROR: Can't find zip file $$p..." || exit 1; \
          fi; \
        done

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=bglpkg/%)

#*---------------------------------------------------------------------*/
#*    directory dependencies                                           */
#*---------------------------------------------------------------------*/
o:
	mkdir -p $@

o/class_s:
	mkdir -p $@

o/class_s/bigloo/bglpkg:
	mkdir -p $@

#*---------------------------------------------------------------------*/
#*    SUFFIXES                                                         */
#*---------------------------------------------------------------------*/
.SUFFIXES:
.SUFFIXES: .scm .o

#*---------------------------------------------------------------------*/
#*    The implicit `.scm.o' rule                                       */
#*---------------------------------------------------------------------*/
o/%.o: %.scm
	$(BIGLOO) -c $(BFLAGS) $(EFLAGS) $< -o $@

o/class_s/bigloo/bglpkg/%.class: %.scm
	$(BIGLOO) -c -jvm $(BFLAGS) $(BJVMFLAGS) $(EFLAGS) $< -o $@

#*---------------------------------------------------------------------*/
#*    ude                                                              */
#*---------------------------------------------------------------------*/
.PHONY: ude
ude:
	@ $(MAKE) -f Makefile .afile .etags dep

.afile: $(FILES) configure.scm Makefile
	@ $(AFILE_BIN) -o .afile $(FILES) configure.scm

.jfile: $(FILES)
	@ $(JFILE_BIN) -o .jfile -pbase bigloo.bglpkg $(FILES) configure.scm

.etags: .afile
	@ $(BTAGS_BIN) -o .etags $(FILES) configure.scm

getsources:
	@ echo $(FILES) configure.scm

#*---------------------------------------------------------------------*/
#*    dep                                                              */
#*---------------------------------------------------------------------*/
.PHONY: dep
dep: 
	@(num=`grep -n '^#bdepend start' Makefile | awk -F: '{ print $$1}' -`;\
          if [ "$$num " != " " ]; then \
            head -n `expr $$num - 1` Makefile > /tmp/Makefile.aux; \
          else \
            cp Makefile /tmp/Makefile.aux; \
          fi)
	@ $(DEPEND_BIN) -strict-obj-dir o -fno-mco $(FILES) >> /tmp/Makefile.aux
	@ mv /tmp/Makefile.aux Makefile

#*---------------------------------------------------------------------*/
#*    install                                                          */
#*---------------------------------------------------------------------*/
.PHONY: install uninstall

install:
	if [ $(BINDIR) != $(BOOTBINDIR) ]; then \
	   cp $(BOOTBINDIR)/bglpkg$(EXE_SUFFIX) $(DESTDIR)$(BINDIR); \
	   chmod $(MODEXE) $(DESTDIR)$(BINDIR)/bglpkg$(EXE_SUFFIX); \
        fi

uninstall:
	- $(RM) -f $(DESTDIR)$(BINDIR)/bglpkg$(EXE_SUFFIX)

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    We prepare bglpkg for a distribution                            */
#*---------------------------------------------------------------------*/
distrib: 
	@ if [ `pwd` = $(BOODIR)/bglpkg ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi
	@ cp $(BOOTDIR)/bglpkg/configure.scm configure.scm
	@ $(MAKE) .afile

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
clean:
	$(RM) -rf o
	$(RM) -rf META-INF

devclean: clean
	$(RM) -f $(BOOTBINDIR)/$(BGLPKG)
	$(RM) -f $(BOOTBINDIR)/$(BGLPKG).jar

cleanall: devclean
	$(RM) -f .afile .jfile

distclean: devclean

#*---------------------------------------------------------------------*/
#*    Dependencies                                                     */
#*---------------------------------------------------------------------*/
$(OBJECTS): .afile

o/install.o: etc/Makefile etc/make_lib.scm etc/init

#bdepend start (don't edit)
#*---------------------------------------------------------------------*/
#*    Dependencies ...                                                 */
#*---------------------------------------------------------------------*/
o/param.o param.class: param.sch 
o/param.o ./param.class: param.sch 
o/mzscheme.o ./mzscheme.class: param.sch 
o/install.o ./install.class: makefile.sch 
o/install.o install.class: makefile.sch 
o/mzscheme.o mzscheme.class: param.sch 

#bdepend stop

=== bmacs/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/bmacs/Makefile                */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Mon Jun  8 08:36:43 1998                          */
#*    Last change :  Sat Jul  2 07:02:37 2022 (serrano)                */
#*    Copyright   :  1998-2022 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The Makefile for the Unified Development environment.            */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, and Tools                                             */
#*---------------------------------------------------------------------*/
# the shell to be used
SHELL           = /bin/sh
# etags and etags file name
ETAGS		= etags
TAGSFILE	= .etags
# configure
CONFIGURE	= $(BOOTDIR)/configure

#*---------------------------------------------------------------------*/
#*    Emacs settings                                                   */
#*---------------------------------------------------------------------*/
LOADPATH	= ude bee cee bug lee dbg

XEMACSFLAGS	= -no-site-file
GNUEMACSFLAGS	= --no-site-file

COMMONFLAGS	= -batch -q -f batch-byte-compile
            
#*---------------------------------------------------------------------*/
#*    Sources and Objects                                              */
#*---------------------------------------------------------------------*/
UDE_FILE	= ude-autoload ude-config ude-custom ude-icon ude-tools \
                  ude-error ude-root ude-compile ude-info ude-repl ude-sui \
                  ude-paren ude-makefile ude-mouse ude-profile ude-about \
                  etags-add plugin id-select \
                  ude-ident ude-docline ude-version ude-balloon

BEE_FILE	= bee-autoload bee-config bee-toolbar bee-indent \
                  bee-mode bee-keymap bee-expand bee-flock bee-module \
                  bee-repl bee-tags bee-profile bee-usage \
                  bee-about-icon bee-ibuilder bee-browse \
                  bee-doc

CEE_FILE	= cee-autoload cee-config cee-toolbar cee-indent \
                  cee-profile cee-gdb cee-flock cee-hook cee-keymap \
                  cee-tags cee-profile cee-kbdb

LEE_FILE	= lee-autoload lee-config lee-toolbar lee-keymap \
                  lee-flock lee-hook lee-indent lee-tags

DBG_FILE	= dbg-args dbg-config dbg-filter dbg-stack \
                  dbg-autoload dbg-connect dbg-locals dbg-toolbar \
                  dbg-console dbg-mode dbg \
                  dbg-display dbg-process dbg-complete \
                  dbg-docline dbg-source dbg-about-icon dbg-breakpoint

BUG_FILE	= bug-args bug-connect bug-hooking bug-source \
                  bug-autoload bug-custom bug-images bug-stack \
                  bug-breakpoint bug bug-toolbar \
                  bug-class bug-filter bug-mode bug-xemacs \
                  bug-config bug-gnu-emacs bug-process

OLD_SOURCES 	= bee/bee-bdb.el bee/bee-kbdb.el

EMACS_DIST_FILE	= $(UDE_FILE:%=ude/%) \
                  $(BEE_FILE:%=bee/%) \
                  $(BUG_FILE:%=bug/%) \
                  $(DBG_FILE:%=dbg/%) \
                  $(CEE_FILE:%=cee/%) \
                  $(LEE_FILE:%=lee/%)

EMACS_FILE	= $(EMACS_DIST_FILE) \
                  $(LEE_FILE:%=lee/%)

BMACS_FILE	= bmacs.el \
                  bmacs-gnu-emacs.el \
                  bmacs-xemacs.el xemacs-etags.el

EMACS_DIST_NODIR= $(UDE_FILE:%=%.el) $(UDE_FILE:%=%.elc) \
                  $(BEE_FILE:%=%.el) $(BEE_FILE:%=%.elc) \
                  $(BUG_FILE:%=%.el) $(BUG_FILE:%=%.elc) \
                  $(DBG_FILE:%=%.el) $(DBG_FILE:%=%.elc) \
                  $(CEE_FILE:%=%.el) $(CEE_FILE:%=%.elc) \
                  $(LEE_FILE:%=%.el) $(LEE_FILE:%=%.elc) \
		  $(BMACS_FILE)                  

EMACS_DIST_OBJ	= $(EMACS_DIST_FILE:%=%.el) $(EMACS_DIST_FILE:%=%.elc) \
                  $(BMACS_FILE)
EMACS_OBJ	= $(EMACS_FILE:%=%.elc)
EMACS_SOURCES	= $(EMACS_FILE:%=%.el) $(BMACS_FILE)

#*---------------------------------------------------------------------*/
#*    Population                                                       */
#*---------------------------------------------------------------------*/
POPULATION	= Makefile README $(EMACS_SOURCES) $(OLD_SOURCES) \
                  etc/bass-snap.au images/*.xpm

#*---------------------------------------------------------------------*/
#*     Suffixes ...                                                    */
#*---------------------------------------------------------------------*/
.SUFFIXES:
.SUFFIXES: .scm .o .el .elc

#*---------------------------------------------------------------------*/
#*    all                                                              */
#*---------------------------------------------------------------------*/
all: $(EMACSBRAND)

emacs22 emacs23 emacs24 emacs25 emacs26 emacs27 emacs28 emacs29:
	(expr=load-path; \
          for p in . $(LOADPATH); do \
             expr="(cons \"../$$p\" (cons \"$$p\" $$expr))"; \
          done; \
	$(MAKE) elc EFLAGS="$(XEMACSFLAGS) -eval '(setq load-path $$expr)' $(COMMONFLAGS)")

emacs21: 
	(expr=load-path; \
         for p in . $(LOADPATH); do \
            expr="(cons \"../$$p\" (cons \"$$p\" $$expr))"; \
         done; \
	$(MAKE) elc EFLAGS="$(XEMACSFLAGS) -eval '(setq load-path $$expr)' $(COMMONFLAGS)")

emacs21.old: 
	(path=; \
         for p in . $(LOADPATH); do \
            path="--directory \"$$p\" $$path"; \
         done; \
	$(MAKE) elc EFLAGS="$(GNUEMACSFLAGS) $$path $(COMMONFLAGS)")

xemacs: 
	(expr=load-path; \
         for p in . $(LOADPATH); do \
            expr="(cons \"$$p\" $$expr)"; \
         done; \
	$(MAKE) elc EFLAGS="$(XEMACSFLAGS) -eval '(setq load-path $$expr)' $(COMMONFLAGS)")

generic: 
	@ echo "*** WARNING: generic (i.e. too old) Emacs not supported."
	@ exit 0

false: 
	@ echo "*** WARNING: Emacs not configured, can't compile."
	@ exit 0

elc: bmacs-config.el $(EMACS_OBJ)

#*---------------------------------------------------------------------*/
#*    compile-bee:                                                     */
#*---------------------------------------------------------------------*/
compile-bee: all

#*---------------------------------------------------------------------*/
#*    uninstall                                                        */
#*---------------------------------------------------------------------*/
uninstall:
	-if [ "$(EMACSDIR) " != " " ]; then \
          for f in $(EMACS_DIST_NODIR); do \
            if [ -f $(EMACSDIR)/$$f ]; then \
              $(RM) -f $(EMACSDIR)/$$f; \
            fi; \
          done; \
        fi

#*---------------------------------------------------------------------*/
#*    install ...                                                      */
#*---------------------------------------------------------------------*/
install: install.$(EMACSBRAND)

install.emacs21: doinstall
install.emacs22: doinstall
install.emacs23: doinstall
install.emacs24: doinstall
install.emacs25: doinstall
install.emacs26: doinstall
install.emacs27: doinstall
install.emacs28: doinstall
install.emacs29: doinstall
install.xemacs: doinstall

install.generic:
	@ echo "*** WARNING: generic Emacs(?) not supported, can't install Emacs support."
	@ exit 0

install.false:
	@ echo "*** WARNING: Emacs not configured, can't install Emacs support."
	@ exit 0

doinstall: bmacs-config.el site-lisp
	@ echo "Installing Emacs file in $(DESTDIR)$(EMACSDIR)..."
	@ for f in $(EMACS_DIST_OBJ) bmacs-config.el; do \
          if [ -f $$f ]; then \
            echo "   ...$$f"; \
	    cp $$f "$(DESTDIR)$(EMACSDIR)"; \
          else \
            echo "   ...$$f (can't find)"; \
          fi; \
        done
	(cd "$(DESTDIR)$(EMACSDIR)"; chmod $(MODFILE) *.el*)
	if [ ! -d "$(DESTDIR)$(EMACSDIR)/etc" ]; then \
          mkdir -p "$(DESTDIR)$(EMACSDIR)/etc" && \
            chmod $(MODDIR) "$(DESTDIR)$(EMACSDIR)/etc"; \
        fi
	cp etc/bass-snap.au "$(DESTDIR)$(EMACSDIR)/etc"
	if [ ! -d "$(DESTDIR)$(EMACSDIR)/images" ]; then \
          mkdir -p "$(DESTDIR)$(EMACSDIR)/images" && \
            chmod $(MODDIR) "$(DESTDIR)$(EMACSDIR)/images"; \
        fi
	cp images/*.xpm "$(DESTDIR)$(EMACSDIR)/images"

site-lisp:
	if [ "$(EMACSDIR) " = " " ]; then \
          echo "*** ERROR: Emacs lisp dir not configured!"; \
          exit 1; \
        else \
	  if [ ! -d "$(DESTDIR)$(EMACSDIR)" ]; then \
            mkdir -p "$(DESTDIR)$(EMACSDIR)" && \
              chmod $(MODDIR) "$(DESTDIR)$(EMACSDIR)"; \
          fi \
        fi

#*---------------------------------------------------------------------*/
#*    touchall                                                         */
#*---------------------------------------------------------------------*/
touchall:
	touch $(EMACS_SOURCES)

#*---------------------------------------------------------------------*/
#*    ude                                                              */
#*---------------------------------------------------------------------*/
.PHONY: ude
ude:
	@ $(ETAGS) $(EMACS_SOURCES) -o $(TAGSFILE)

#*---------------------------------------------------------------------*/
#*     clean ...                                                       */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean

clean: 
	@- $(RM) -f $(EMACS_OBJ)
	@ find . \( -name '*[~%]' \
                       -o -name '.??*[~%]' \
                       -o -name '#*#' \
                       -o -name '?*#' \
                       -o -name \*core \) \
                     -type f -exec rm {} \;   
	@ echo "cleanup done..."
	@ echo "-------------------------------"

cleanall: clean
	@ $(RM) -f $(TAGSFILE)

distclean: cleanall

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    Prepare Cigloo for a distribution                                */
#*---------------------------------------------------------------------*/
distrib:
	@ if [ `pwd` = $(BOOTDIR)/bmacs ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*    -------------------------------------------------------------    */
#*    This entry is used by the bigloo/Makefile (the main Bigloo       */
#*    makefile) to get the list of file that populate a revision.      */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=bmacs/%)

#*---------------------------------------------------------------------*/
#*    bmacs-config.el                                                  */
#*---------------------------------------------------------------------*/
bmacs-config.el: $(BOOTDIR)/configure $(BOOTDIR)/Makefile
	$(BOOTDIR)/configure --bigloo_config.el=$(BOOTDIR)/bmacs/bmacs-config.el \
                             --libdir=$(BOOTLIBDIR) \
                             --zipdir=$(BOOTLIBDIR) \
                             --indent=stdindent \
                             --no-summary \
                             --bootdir=$(BOOTDIR)
	$(RM) -f configure.log

=== cigloo/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/cigloo/Makefile                      */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Jan 14 14:46:31 1998                          */
#*    Last change :  Sun Jul  9 10:22:24 2017 (serrano)                */
#*    Copyright   :  1998-2017 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The Makefile to build Cigloo. This makefile has to be processed  */
#*    either by Gnu make or Sun make.                                  */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Default configuration                                            */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# the shell to be used
SHELL           = /bin/sh
# the produced executable
CIGLOO_DEST	= $(BOOTBINDIR)/cigloo$(EXE_SUFFIX)

#*---------------------------------------------------------------------*/
#*    Compilation flags                                                */
#*---------------------------------------------------------------------*/
BFLAGS		= -lib-dir $(BOOTLIBDIR) -afile .afile -O2 -fsharing -unsafe $(SHRD_BDE_OPT)
EFLAGS		=

#*---------------------------------------------------------------------*/
#*    Les sources                                                      */
#*---------------------------------------------------------------------*/
#*--- init ------------------------------------------------------------*/
INIT_FILE	= main setrc parse_args

INIT_OBJ	= $(INIT_FILE:%=Init/%.o)

#*--- engine ----------------------------------------------------------*/
ENGINE_FILE	= engine param translate

ENGINE_OBJ	= $(ENGINE_FILE:%=Engine/%.o)

#*--- translate -------------------------------------------------------*/
TRANSLATE_FILE	= function declaration type decl tspec expr eval ident

TRANSLATE_OBJ	= $(TRANSLATE_FILE:%=Translate/%.o)


#*--- tools -----------------------------------------------------------*/
TOOLS_FILE	= speek error

TOOLS_OBJ	= $(TOOLS_FILE:%=Tools/%.o)

#*--- write -----------------------------------------------------------*/
WRITE_FILE	= version

WRITE_OBJ	= $(WRITE_FILE:%=Write/%.o)

#*--- parser ---------------------------------------------------------*/
PARSER_FILE	= parser lexer tools cpp

PARSER_OBJ	= $(PARSER_FILE:%=Parser/%.o)

#*---------------------------------------------------------------------*/
#*    Tout le code ...                                                 */
#*---------------------------------------------------------------------*/
O_OBJECTS       = $(INIT_OBJ) $(ENGINE_OBJ) $(PARSE_OBJ) $(TOOLS_OBJ) \
                  $(WRITE_OBJ) $(PARSER_OBJ) $(TRANSLATE_OBJ)

SOURCE_FILES	= $(O_OBJECTS:%.o=%.scm)

POPULATION	= $(SOURCE_FILES) \
                  Makefile \
                  Parser/coord.sch \
                  Translate/ast.sch \
                  Translate/type.sch \
                  Translate/function.sch \
                  Tools/union.sch \
                  Example/Makefile \
	 	  Example/b_file.scm \
	          Example/c_file.h \
	          Example/c_file.c \
                  README \
                  .afile

#*---------------------------------------------------------------------*/
#*     Les suffixes ...                                                */
#*---------------------------------------------------------------------*/
.SUFFIXES:
.SUFFIXES: .scm .c .o

#*---------------------------------------------------------------------*/
#*    L'executable `cigloo'                                            */
#*---------------------------------------------------------------------*/
cigloo:
	@ $(MAKE) $(CIGLOO_DEST)

#*---------------------------------------------------------------------*/
#*    $(CIGLOO_DEST)                                                   */
#*---------------------------------------------------------------------*/
$(CIGLOO_DEST): $(O_OBJECTS)
	@ echo "Linking:"
	@ $(BIGLOO) $(BFLAGS) $(EFLAGS) $(O_OBJECTS) -o $(CIGLOO_DEST)
	@- $(STRIP) $(CIGLOO_DEST)
	@ echo "Cigloo Done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    install                                                          */
#*---------------------------------------------------------------------*/
.PHONY: install uninstall

install:
	if [ $(DESTDIR)$(BINDIR) != $(BOOTBINDIR) ]; then \
	   cp $(BOOTBINDIR)/cigloo$(EXE_SUFFIX) $(DESTDIR)$(BINDIR); \
	   chmod $(MODEXE) $(DESTDIR)$(BINDIR)/cigloo$(EXE_SUFFIX); \
        fi

uninstall:
	- $(RM) -f $(DESTDIR)$(BINDIR)/cigloo$(EXE_SUFFIX)

#*---------------------------------------------------------------------*/
#*    afile                                                            */
#*---------------------------------------------------------------------*/
afile: 
	@ echo "   - " .afile
	@ $(BGLAFILE) -o .afile $(SOURCE_FILES)
	@ echo "   - dep"
	@ $(MAKE) dep
	@ echo "   - .etags"
	@ $(MAKE) tags

#*---------------------------------------------------------------------*/
#*    tags                                                             */
#*---------------------------------------------------------------------*/
tags:
	@ $(BGLTAGS) -o .etags $(SOURCE_FILES) 

#*---------------------------------------------------------------------*/
#*    dep                                                              */
#*---------------------------------------------------------------------*/
dep.old:
	@(num=`grep -n '^#bdepend start' Makefile | awk -F: '{ print $$1}' -`;\
          head -n `expr $$num - 1` Makefile > /tmp/Makefile.aux)
	@ $(BDEPEND_EXE) -fno-mco $(SOURCE_FILES) >> /tmp/Makefile.aux
	@ mv /tmp/Makefile.aux Makefile

dep:
	@ $(BGLDEPEND) -fno-mco $(SOURCE_FILES) -o Makefile

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    We prepare the compiler for a distribution                       */
#*---------------------------------------------------------------------*/
distrib: 
	@ if [ `pwd` = $(BOODIR)/cigloo ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi
	@ $(MAKE) cleanall
	@ $(MAKE) afile
	$(RM) -f .afile~ Makefile~

#*---------------------------------------------------------------------*/
#*     clean ...                                                       */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean

clean:
	@- $(RM) -f $(O_OBJECTS)
	@- $(RM) -f $(O_OBJECTS:%.o=%.c)
	@- $(RM) -f .etags
	@ find . \( -name '*[~%]' \
                       -o -name '.??*[~%]' \
                       -o -name '#*#' \
                       -o -name '?*#' \
                       -o -name \*core \) \
                     -type f -exec $(RM) {} \;   
	@ (cd Example; $(MAKE) clean)
	@ echo "cleanup done..."
	@ echo "-------------------------------"

cleanall: clean
	@- $(RM) -f $(CIGLOO_DEST)

distclean: cleanall

#*---------------------------------------------------------------------*/
#*     touchall ...                                                    */
#*---------------------------------------------------------------------*/
touchall:
	@ touch $(SOURCE_FILES)
	@ echo "touchall done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    link ...                                                         */
#*---------------------------------------------------------------------*/
link:
	@ echo "Linking:"
	@ $(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(CIGLOO_DEST) Init/main.o $(O_OBJECTS) -lm
	@ echo "link done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*    -------------------------------------------------------------    */
#*    This entry is used by the bigloo/Makefile (the main Bigloo       */
#*    makefile) to get the list of file that populate a revision.      */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=cigloo/%)

#*---------------------------------------------------------------------*/
#*     .scm --> .o                                                     */
#*---------------------------------------------------------------------*/
.scm.o:
	@ $(BIGLOO) $(BFLAGS) $(EFLAGS) -c $*.scm -o $*.o

#*---------------------------------------------------------------------*/
#*     .scm --> .c                                                     */
#*---------------------------------------------------------------------*/
.scm.c:
	@ $(BIGLOO) $(BFLAGS) $(EFLAGS) -C $*.scm -o $*.o

#*---------------------------------------------------------------------*/
#*    Parser/parser.o:                                                 */
#*---------------------------------------------------------------------*/
Parser/parser.o: Parser/parser.scm 
	@ $(BIGLOO) $(BOPTFLAGS) $(BFLAGS) $(EFLAGS) -c $*.scm -o $*.o

#*---------------------------------------------------------------------*/
#*    Parser/cpp.o:                                                    */
#*---------------------------------------------------------------------*/
Parser/cpp.o: Parser/cpp.scm 
	@ $(BIGLOO) $(BOPTFLAGS) $(BFLAGS) $(EFLAGS) -c $*.scm -o $*.o

#*---------------------------------------------------------------------*/
#*    Parser/lexer.o:                                                  */
#*---------------------------------------------------------------------*/
Parser/lexer.o: Parser/lexer.scm 
	@ $(BIGLOO) $(BOPTFLAGS) $(BFLAGS) $(EFLAGS) -c $*.scm -o $*.o

#bdepend start (don't edit)
#*---------------------------------------------------------------------*/
#*    Dependencies ...                                                 */
#*---------------------------------------------------------------------*/
Translate/ast.sch: Tools/union.sch 
Parser/parser.o Parser/parser.class: Translate/ast.sch 
./Tools/error.o ./Tools/error.class: Translate/ast.sch Parser/coord.sch 
./Parser/parser.o ./Parser/parser.class: Translate/ast.sch 
Translate/function.o Translate/function.class: Parser/coord.sch          \
      Translate/ast.sch Translate/type.sch Translate/function.sch 
Parser/cpp.o Parser/cpp.class: Parser/coord.sch 
./Translate/expr.o ./Translate/expr.class: Translate/ast.sch             \
      Translate/type.sch 
Translate/decl.o Translate/decl.class: Parser/coord.sch                  \
      Translate/ast.sch Translate/type.sch 
Translate/expr.o Translate/expr.class: Translate/ast.sch                 \
      Translate/type.sch 
./Translate/type.o ./Translate/type.class: Translate/ast.sch             \
      Translate/type.sch 
Translate/tspec.o Translate/tspec.class: Translate/ast.sch               \
      Translate/type.sch 
Engine/translate.o Engine/translate.class: Parser/coord.sch              \
      Translate/ast.sch 
Parser/tools.o Parser/tools.class: Parser/coord.sch 
Tools/error.o Tools/error.class: Translate/ast.sch Parser/coord.sch 
Translate/declaration.o Translate/declaration.class: Translate/ast.sch   \
      Translate/type.sch

=== comptime/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bigloo/comptime/Makefile             */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Jan 14 08:29:03 1998                          */
#*    Last change :  Fri Dec 13 08:23:49 2024 (serrano)                */
#*    Copyright   :  1998-2024 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The Makefile to build the compiler part of Bigloo (bootstrap).   */
#*    This Makefile has to be processed by Gnu make.                   */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Default configuration                                            */
#*---------------------------------------------------------------------*/
include ../Makefile.buildconfig
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# the produced executable
BIGLOO_DEST	= $(BOOTBINDIR)/bigloo
# the shell to be used
SHELL           = /bin/sh
# another produced executable
NEW_SUFFIX	= new
# another target.
DEFAULT		= plain
# These variables control how we are booting (from Scheme or C)
SCMOBJSUFFIX	= %.o
SCMCLASSSUFFIX	= %.class
COBJSUFFIX	= 
CSRCSUFFIX	= 

#*---------------------------------------------------------------------*/
#*    Bigloo compilation flags                                         */
#*---------------------------------------------------------------------*/
LIBDIRFLAGS	= -lib-dir $(BOOTLIBDIR)
# Commmon flags
COMMONFLAGS	= -q \
                  -afile .afile \
                  -fsharing \
                  -fno-reflection \
                  -cc $(CC) \
                  $(LIBDIRFLAGS) \
                  -unsafev \
                  -gno-error-localization \
                  -no-hello
# Optimized _and_ debugged compilation
OGBFLAGS        = $(COMMONFLAGS) -Wall -O2 -rm -g $(BOOTFLAGS)
# Bootstrap flag
#BFLAGS		= $(OGBFLAGS)       
BFLAGS		= $(COMMONFLAGS) -Wall -O2 $(BOOTFLAGS)
EFLAGS		=
# Distribution flag
BDISTFLAGS	= $(COMMONFLAGS) -O2 -rm -unsafe -s
# Distribution Jvm flag
BJVMFLAGS	= $(BDISTFLAGS) -lib-dir $(BOOTLIBDIR)
# Link flag
LDBOOTFLAGS     = -static-bigloo $(LDSTRIPFLAGS)
# C compiler flag
CADDFLAGS	= -I$(BOOTLIBDIR)

#*---------------------------------------------------------------------*/
#*    License                                                          */
#*---------------------------------------------------------------------*/
LICENSE		= ../LICENSE

#*---------------------------------------------------------------------*/
#*    The compiler source files ...                                    */
#*---------------------------------------------------------------------*/
#*--- init ------------------------------------------------------------*/
INIT_FILE_NOMAIN= parse_args setrc extend lib_dir
INIT_FILE	= $(INIT_FILE_NOMAIN) main

INIT_OBJ_NOMAIN	= $(INIT_FILE_NOMAIN:%=Init/%.o)
INIT_OBJ	= $(INIT_FILE:%=Init/%.o)

#*--- tools -----------------------------------------------------------*/
TOOLS_FILE	= args location progn trace speek error shape misc \
                  dsssl

TOOLS_OBJ	= $(TOOLS_FILE:%=Tools/%.o)

#*--- engine ----------------------------------------------------------*/
ENGINE_FILE	= compiler engine param interp link signals pass \
                  configure heap

ENGINE_OBJ	= $(ENGINE_FILE:%=Engine/%.o)

#*--- heap ------------------------------------------------------------*/
HEAP_FILE	= restore make

HEAP_OBJ	= $(HEAP_FILE:%=Heap/%.o)

#*--- write -----------------------------------------------------------*/
WRITE_FILE	= version expanded scheme ast

WRITE_OBJ	= $(WRITE_FILE:%=Write/%.o)

#*--- read ------------------------------------------------------------*/
READ_FILE	= access include src inline load reader jvm

READ_OBJ	= $(READ_FILE:%=Read/%.o)

#*--- module ----------------------------------------------------------*/
MODULE_FILE	= foreign impuse main prototype with class include \
                  module statexp eval load pragma type library checksum \
                  option alibrary java wasm

MODULE_OBJ	= $(MODULE_FILE:%=Module/%.o)

#*--- ast -------------------------------------------------------------*/
AST_FILE	= build venv glo_decl node unit dump glo_def pragma \
                  var find_gdefs ident remove local sexp labels let \
                  exit substitute alphatize occur toccur app apply lvtype \
                  hrtype shrinkify check_init private check_sharing init \
                  check_type object walk

AST_OBJ		= $(AST_FILE:%=Ast/%.o)

#*--- beta ------------------------------------------------------------*/
BETA_FILE	= walk

BETA_OBJ	= $(BETA_FILE:%=Beta/%.o)

#*--- cc --------------------------------------------------------------*/
CC_FILE		= exec indent cc ld roots

CC_OBJ		= $(CC_FILE:%=Cc/%.o)

#*--- foreign ---------------------------------------------------------*/
FOREIGN_FILE	= access cenum cptr ctype calias cfun cstruct copaque \
                  library jtype
 
FOREIGN_OBJ	= $(FOREIGN_FILE:%=Foreign/%.o)

#*--- Type ------------------------------------------------------------*/
TYPE_FILE	= cache tenv type coercion tools typeof pptype misc

TYPE_OBJ	= $(TYPE_FILE:%=Type/%.o)

#*--- expand ----------------------------------------------------------*/
EXPAND_FILE	= eps assert case define expander garith iarith farith \
                  if initial lambda let map struct exit object mvalue \
                  callcc

EXPAND_OBJ	= $(EXPAND_FILE:%=Expand/%.o)

#*--- inline ----------------------------------------------------------*/
INLINE_FILE	= walk inline app size simple recursion variant loop

INLINE_OBJ	= $(INLINE_FILE:%=Inline/%.o)

#*--- fxop ------------------------------------------------------------*/
FXOP_FILE	= walk

FXOP_OBJ	= $(FXOP_FILE:%=Fxop/%.o)

#*--- flop ------------------------------------------------------------*/
FLOP_FILE	= walk

FLOP_OBJ	= $(FLOP_FILE:%=Flop/%.o)

#*--- coerce ----------------------------------------------------------*/
COERCE_FILE	= walk pproto coerce app funcall apply convert

COERCE_OBJ	= $(COERCE_FILE:%=Coerce/%.o)

#*--- Prebox ----------------------------------------------------------*/
PREBOX_FILE	= walk

PREBOX_OBJ	= $(PREBOX_FILE:%=Prebox/%.o)

#*--- Dataflow --------------------------------------------------------*/
DATAFLOW_FILE	= walk

DATAFLOW_OBJ	= $(DATAFLOW_FILE:%=Dataflow/%.o)

#*--- Initflow --------------------------------------------------------*/
INITFLOW_FILE	= walk

INITFLOW_OBJ	= $(INITFLOW_FILE:%=Initflow/%.o)

#*--- stackable -------------------------------------------------------*/
STACKABLE_FILE  = walk

STACKABLE_OBJ   = $(STACKABLE_FILE:%=Stackable/%.o)

#*--- globalize -------------------------------------------------------*/
GLOBALIZE_FILE	= walk ginfo escape gn node free kapture \
                  integration new_body loc2glo gloclo clocto globalize

GLOBALIZE_OBJ	= $(GLOBALIZE_FILE:%=Globalize/%.o)

#*--- cnst ------------------------------------------------------------*/
CNST_FILE	= walk cache alloc node initialize

CNST_OBJ	= $(CNST_FILE:%=Cnst/%.o)

#*--- cfa -------------------------------------------------------------*/
CFA_FILE	= app cinfo iterate set approx collect loose show walk \
                  setup vector pair cfa funcall procedure struct type \
                  closure tvector box specialize cinfo2 cinfo3 \
                  arithmetic ltype

CFA_OBJ		= $(CFA_FILE:%=Cfa/%.o)

#*--- Integrate -------------------------------------------------------*/
INTEGRATE_FILE	= walk definition iinfo a kk u g ctn cto kaptured \
                  let_fun loc2glo node free volatile

INTEGRATE_OBJ	= $(INTEGRATE_FILE:%=Integrate/%.o)

#*--- Tailc -----------------------------------------------------------*/
TAILC_FILE	= walk

TAILC_OBJ	= $(TAILC_FILE:%=Tailc/%.o)

#*--- Cgen ------------------------------------------------------------*/
CGEN_FILE	= compile cop emit_cop cgen capp

CGEN_OBJ	= $(CGEN_FILE:%=Cgen/%.o)

#*--- Jas -------------------------------------------------------------*/
JAS_FILE        = lib classfile opcode peep wide labels stack profile produce as

JAS_OBJ		= $(JAS_FILE:%=Jas/%.o)

#*--- Jvm -------------------------------------------------------------*/
JVM_FILE	= extern env instr inline peephole lisp prelude compress \
                  init constr closure \
                  compiler tail effect predicate expr \
                  compile jdump jld vmemq

JVM_OBJ		= $(JVM_FILE:%=Jvm/%.o)

#*--- BackEnd ---------------------------------------------------------*/
BACKEND_FILE    = backend walk init lib cplib cvm bvm \
                  c c_main c_proto c_emit  \
                  jvm jvm_class

BACKEND_OBJ	= $(BACKEND_FILE:%=BackEnd/%.o)

#*--- SawMill ---------------------------------------------------------*/
SAW_FILE        = lib defs rtl node2rtl collapse remove inlinereturn \
		  blockorder gotos cast expr woodcutter \
		  procedures elsewhere regalloc regset regutils

SAW_OBJ		= $(SAW_FILE:%=SawMill/%.o)

#*--- SawBbv ----------------------------------------------------------*/
SAW_BBV_FILE    = bbv bbv-types bbv-specialize bbv-cache bbv-utils \
                  bbv-range bbv-merge bbv-cost bbv-config bbv-liveness \
                  bbv-optim bbv-debug bbv-profile bbv-gc

SAW_BBV_OBJ	= $(SAW_BBV_FILE:%=SawBbv/%.o)

#*--- SawC ------------------------------------------------------------*/
SAW_C_FILE      = compile code

SAW_C_OBJ	= $(SAW_C_FILE:%=SawC/%.o)

#*--- SawJvm ----------------------------------------------------------*/
SAW_JVM_FILE	= compile type code inline funcall names out jld

SAW_JVM_OBJ	= $(SAW_JVM_FILE:%=SawJvm/%.o)

#*--- Hgen ------------------------------------------------------------*/
HGEN_FILE	= walk

HGEN_OBJ	= $(HGEN_FILE:%=Hgen/%.o)

#*--- tvector ---------------------------------------------------------*/
TVECTOR_FILE	= tvector access cnst

TVECTOR_OBJ	= $(TVECTOR_FILE:%=Tvector/%.o)

#*--- trace -----------------------------------------------------------*/
TRACE_FILE	= walk isloop

TRACE_OBJ	= $(TRACE_FILE:%=Trace/%.o)

#*--- fail ------------------------------------------------------------*/
FAIL_FILE	= walk

FAIL_OBJ	= $(FAIL_FILE:%=Fail/%.o)

#*--- callcc ----------------------------------------------------------*/
CALLCC_FILE	= walk

CALLCC_OBJ	= $(CALLCC_FILE:%=Callcc/%.o)

#*--- reduce ----------------------------------------------------------*/
REDUCE_FILE	= walk cond typec ftypec copy cse same 1occ sbeta

REDUCE_OBJ	= $(REDUCE_FILE:%=Reduce/%.o)

#*--- effect ----------------------------------------------------------*/
EFFECT_FILE	= effect walk cgraph spread feffect

EFFECT_OBJ	= $(EFFECT_FILE:%=Effect/%.o)

#*--- sync ------------------------------------------------------------*/
SYNC_FILE	= node failsafe

SYNC_OBJ	= $(SYNC_FILE:%=Sync/%.o)

#*--- object ----------------------------------------------------------*/
OBJECT_FILE	= class generic method getter \
                  java_access \
                  slots tools coercion predicate creator nil \
                  classgen

OBJECT_OBJ	= $(OBJECT_FILE:%=Object/%.o)

#*--- bdb -------------------------------------------------------------*/
BDB_FILE	= setting spread_obj bdb_initialize walk bdb_emit

BDB_OBJ		= $(BDB_FILE:%=Bdb/%.o)

#*--- prof ------------------------------------------------------------*/
PROF_FILE	= unit prof_emit

PROF_OBJ	= $(PROF_FILE:%=Prof/%.o)

#*--- bound -----------------------------------------------------------*/
ABOUND_FILE	= walk

ABOUND_OBJ	= $(ABOUND_FILE:%=Abound/%.o)

=== doc/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/doc/Makefile                         */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Jan 14 15:08:14 2004                          */
#*    Last change :  Fri Dec  1 10:22:23 2017 (serrano)                */
#*    Copyright   :  2004-17 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    The Makefile for managing the DOC Bigloo directory               */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:

#*---------------------------------------------------------------------*/
#*    population                                                       */
#*    -------------------------------------------------------------    */
#*    The list of all files that have to be placed inside the          */
#*    repository for revision.                                         */
#*---------------------------------------------------------------------*/
pop:
	@ echo doc/Makefile \
               doc/README.ppc doc/README.sgi \
               doc/README.alpha doc/README.openbsd \
               doc/README.finalizer doc/README.fp \
               doc/README.win32 doc/README.jvm \
               doc/README.athlon doc/README.pentium \
               doc/README.icc doc/README.benchmark \
               doc/README.hppa \
               doc/README.aix doc/README.aix.html \
               doc/README.sparc-linux \
               doc/README.mingw \
               doc/README.macosx doc/README.solaris \
               doc/README.android doc/README.raspberry

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:

=== PKGBUILD ===
# Maintainer: Jürgen Hötzel <juergen@archlinux.org>
# Contributor: John Proctor <jproctor@prium.net>
# Contributor: Kevin Piche <kevin@archlinux.org>

pkgname=bigloo
pkgver=4.6a
_src_ver=${pkgver/_/-}
pkgrel=1
pkgdesc="Fast scheme compiler"
arch=('x86_64')
url="https://www-sop.inria.fr/mimosa/fp/Bigloo/"
license=('GPL' 'LGPL')
depends=('gmp' 'openssl' 'libunistring' 'libnsl' 'gc' 'libuv')
makedepends=('emacs' 'zip' 'sqlite' 'alsa-lib' 'flac' 'avahi' 'libpulse')
optdepends=('emacs' 'zip' 'sqlite' 'alsa-lib' 'flac' 'avahi')
options=('!makeflags' '!lto')
source=("https://www-sop.inria.fr/indes/fp/Bigloo/download/${pkgname}-${_src_ver}.tar.gz" "bigloo-gcc15.patch")
sha256sums=('9705ec3de00cc1c51ee7699894841a3770c06a874215b45635b8844ae6daf0a6'
            'dfaa8c0709c5274b7805080856f8a4abcff20cd6ca22d77aeafbebd252a56c68')


elisp_dir=/usr/share/emacs/site-lisp/bigloo

prepare() {
  sed -i 's/$(GCLIB)/c/' "${srcdir}/${pkgname}-${_src_ver}/configure"
  patch -p0 -d "${srcdir}/${pkgname}-${_src_ver}"  -i "${srcdir}/${pkgname}-gcc15.patch"
  # The sources are not ready for C23
  export CFLAGS+=" -std=gnu17 -D_GNU_SOURCE=1 -fwrapv -Wno-unused"
  sed -i 's/TLS=thread_local/TLS=_Thread_local/;s/"thread_local"/"_Thread_local"/' "${srcdir}/${pkgname}-${_src_ver}/autoconf/pthreadlocalstorage"
  # Build blib with the correct flags
  sed -i "s|^CFLAGS.*|& $CFLAGS|" "${srcdir}/${pkgname}-${_src_ver}/bdb/blib/Makefile"
}

build() {
  cd "${srcdir}/${pkgname}-${_src_ver}"
  # Large stack needed to build
  ulimit -s unlimited
  ./configure --prefix=/usr \
    --docdir=/usr/share/doc/bigloo \
    --mandir=/usr/share/man \
    --infodir=/usr/share/info \
    --lispdir=${elisp_dir} \
    --coflags="$CFLAGS" \
    --cpicflags="-fPIC" \
    --customgc=no \
    --customgmp=no \
    --customlibuv=no \
    --native-default-backend \
    --enable-avahi \
    --enable-flac \
    --enable-sqlite \
    --enable-ssl \
    --disable-gstreamer

  make build compile-bee
}

check() {
  cd "${srcdir}/${pkgname}-${_src_ver}"
  make test
}

package() {
  cd "${srcdir}/${pkgname}-${_src_ver}"

  make DESTDIR="${pkgdir}" install install-bee
  make -C manuals DESTDIR="${pkgdir}" install-bee

  # Remove references to the build root
  sed -e "s|^BOOTDIR=.*|BOOTDIR=/usr|g" \
      -e "s|^BOOTBINDIR=.*|BOOTBINDIR=/usr/bin|g" \
      -e "s|^BOOTLIBDIR=.*|BOOTLIBDIR=/usr/lib/bigloo/${_src_ver}|g" \
      -e "s|^BGLBUILDBINDIR=.*|BGLBUILDBINDIR=/usr/bin|g" \
      -e "s|^BGLBUILDLIBDIR=.*|BGLBUILDLIBDIR=/usr/lib/bigloo/${_src_ver}|g" \
      -e "s|^\(BIGLOO=.*\)\.sh|\1|" \
      -e "s|^\(BGL.*=.*\)\.sh|\1|" \
      -i  "${pkgdir}/usr/lib/bigloo/${_src_ver%-*}/Makefile.config"

}
